;~ ;*********************************************
		_Author_		=	Shyangs
		_Name_			=	DelFxExtLocal
		_Version_		=	0.3.1
		_ReleaseDate_	=	2010/12/18
		_Compiler_  	=	AutoHotkey_La r52
;~ ;*********************************************

#include QA.ahk				; http://www.chocomus.com/qa_en/
#include tf.ahk				; http://www.autohotkey.net/~hugov/tf-lib.htm
#include ZipFolder.ahk		; http://www.autohotkey.com/forum/topic19831.html

;" 全域變數
_pathLogFile_		:=	A_ScriptDir . "\log_" . A_Now . ".txt"	;" log檔路徑
QA_Create(_arrExtDirName_)	;" 建立陣列，儲存套件資料夾名
QA_Create(_arrExtID_)		;" 建立陣列，儲存套件ID (資料夾名稱)
QA_Create(_arrExtName_)		;" 建立陣列，儲存套件名稱
QA_Create(_arrLangTag_)

FileEncoding, UTF-8-RAW

fLang(var){
	global _langCode_, _Version_, _ReleaseDate_
	
	zhTW_msgAbout := "程式名:`tDelFxExtLocal`n版本號:`t" . _Version_ . "`n發佈日:`t" . _ReleaseDate_ . "`n`nCopyright (C) 2010  Shyangs"
	zhTW_msgInvalidLangTag := " 不是合法的語言代碼！"
	zhTW_msgPlzPutinExtDir := "請將本程式放在 extensions 目錄底下！"
	zhTW_msgPlzCloseFx := "請關閉 Firefox，再執行本程式！"
	zhTW_msgNoCompressionModule := "未安裝 7-Zip 或 zipfldr.dll !"
	zhTW_msgFinished := "已完成！"
	enUS_msgAbout := "Name:`tDelFxExtLocal`nVersion:`t" . _Version_ . "`nRelease:`t" . _ReleaseDate_ . "`n`nCopyright (C) 2010  Shyangs"
	enUS_msgInvalidLangTag := " is invalid Language code!"
	enUS_msgPlzPutinExtDir := "Please put this program in the extensions directory."
	enUS_msgPlzCloseFx := "Please close Firefox, and then run this program."
	enUS_msgNoCompressionModule := "7-Zip or zipfldr.dll does not install!"
	enUS_msgFinished := "Finished!"

	zhTW_menuHomepage := "首頁 (&H)"
	zhTW_menuAbout := "關於 (&A)"
	zhTW_menuLang := "語言 (&L)"
	zhTW_menuHelp := "說明 (&H)"
	enUS_menuHomepage := "Homepage (&H)"
	enUS_menuAbout := "About (&A)"
	enUS_menuLang := "Language (&L)"
	enUS_menuHelp := "Help (&H)"
	
	zhTW_LevelStore := "封存"
	zhTW_LevelFastest := "最快速"
	zhTW_LevelFast := "快速"
	zhTW_LevelNormal := "一般"
	zhTW_LevelMaximum := "最大"
	zhTW_LevelUltra := "極致"
	zhTW_muiModule := "壓縮模組: "
	zhTW_muiLevel := "壓縮層級: "
	zhTW_muiLevelList := "封存|最快速|快速|一般|最大|極致"
	zhTW_muiSave := "保留語系: en-US,"
	zhTW_muiTextEditSave := "zh-TW, zh-HK, zh-CN"
	zhTW_muiLvTitle := "擴充套件名稱|擴充套件ID|上次清理日期"
	zhTW_muiSelectAll := "全部勾選"
	zhTW_muiUnSelectAll := "全不勾選"
	zhTW_muiSmart := "智慧選擇"
	zhTW_muiStartClean := "開始清理"
	zhTW_muiLogFile := "生成記錄檔"
	zhTW_muiTotal := "套件數: "
	enUS_LevelStore := "Store"
	enUS_LevelFastest := "Fastest"
	enUS_LevelFast := "Fast"
	enUS_LevelNormal := "Normal"
	enUS_LevelMaximum := "Maximum"
	enUS_LevelUltra := "Ultra"
	enUS_muiModule := "Module: "
	enUS_muiLevel := "Level: "
	enUS_muiLevelList := "Store|Fastest|Fast|Normal|Maximum|Ultra"
	enUS_muiSave := "Save: en-US,"
	enUS_muiTextEditSave := ""
	enUS_muiLvTitle := "Name|ID|Last cleaned date"
	enUS_muiSelectAll := " Select all "
	enUS_muiUnSelectAll := "Unselect all"
	enUS_muiSmart := "Smartly Select"
	enUS_muiStartClean := "Start"
	enUS_muiLogFile := "Log file"
	enUS_muiTotal := "Total: "
	
	zhTW_puiDetails := "細節`:"	;" 「節」的第二個byte包含「`」（AHK中的轉義符）。使用時，在文字後面插入一個「`」
	zhTW_puiInProcess := "執行中...。 請勿強行關閉程式或干擾相關檔案操作！"
	enUS_puiDetails := "Details:"
	enUS_puiInProcess := "Don't close this program while it is still running."
	
	zhTW_editDelLocal := ", 刪除語系檔 "
	zhTW_editDecompress := ", 解壓縮 "
	zhTW_editCompress := ", 壓縮 "
	zhTW_editFileOrFloder := ", 將檔案/資料夾 "
	zhTW_editAdd2ZipFile := " 加入壓縮檔 "
	zhTW_editStart := ", DelFxExtLocal 開始清理。"
	zhTW_editHandle := ", 處理套件 "
	zhTW_editFinished := ", 全部完成，程式關閉。"
	enUS_editDelLocal := ", delete local: "
	enUS_editDecompress := ", decompress "
	enUS_editCompress := ", compress "
	enUS_editFileOrFloder := ", add "
	enUS_editAdd2ZipFile := " to "
	enUS_editStart := ", DelFxExtLocal started."
	enUS_editHandle := ", handle "
	enUS_editFinished := ", finished."
	
	zhTW_unknown := "未知"
	enUS_unknown := "unknown"
	
	var := _langCode_ . var
	var := %var%
	return, var
}

;" 從陣列中，移除特定元素
fQA_RemoveValue(ByRef arr, value){
	index	:=	QA_IndexOf(arr, value)
	if(	0	=	index	){
		Return
	}else{
		QA_Remove(arr, index)
	}
}

;" 從陣列中，移除全部元素
fQA_RemoveAll(ByRef arr){
	len	:=	QA_Length(arr)
	Loop, %len%
	{
		index := len + 1 - A_index
		QA_Remove(arr, index)
	}
}

;" 將檔案/資料夾名稱 存入 陣列. numType=0 檔案, =1 檔案和資料夾, =2 資料夾
fFileFolderArray(path, numType, ByRef arr){
	path := path . "\*"
	Loop, % path, %numType%
	{
		QA_Push(arr, A_LoopFileName)		
	}
}

;" 字串分割為一個字串陣列
fQA_StringSplit(ByRef arr, inputStr, delimiters){
	Loop, Parse, inputStr, % delimiters
	{
		QA_Push(arr, A_LoopField)
	}
}

;" 檢查本程式放置之目錄
fIsInExtensionsDir(ByRef arrSDP){
	lenSDP	:=	QA_Length(arrSDP)
	elmSDP	:=	QA_Get(arrSDP, lenSDP)
	if (	"extensions"	!=	elmSDP	){
		MsgBox,	4112,, % fLang("msgPlzPutinExtDir") ; "請將本程式放在 extensions 目錄底下！"
		ExitApp
	}
}

fCheckLangTag( strLangTag ){
	global _arrLangTag_
	fQA_RemoveAll(_arrLangTag_)
	strRegex :="^\s*([A-Za-z]{2,4}(?:-[A-Za-z]{2,4})*)\s*$"
	fQA_StringSplit( _arrLangTag_, strLangTag, ",")
	lenLT := QA_Length(_arrLangTag_)
	Loop, %lenLT%
	{
		elmLT :=  QA_Get(_arrLangTag_, A_Index)
		bln := RegExMatch(elmLT, strRegex, langTag)
		If( !bln ){
			MsgBox, 4112,,% elmLT . fLang("msgInvalidLangTag") ; " 不是合法的語言代碼"
			Gui, Show
			Exit	;" Exit current thread 中止執行緒
		}
		QA_Push(_arrLangTag_, langTag1)
	}
	QA_Push(_arrLangTag_, "en-US")
}

;" 檢查 Fx 是否關閉
fIsFxClosed(ByRef arrSDP){
	lenSDP			:=	QA_Length(arrSDP)
	QA_Remove(arrSDP, lenSDP)
	pathProfile		:=	QA_ToString(arrSDP, "\")
	pathParentLock	:=	pathProfile . "\parent.lock"
	if(	""	!=	FileExist(pathParentLock)	){
		MsgBox,	4112,, % fLang("msgPlzCloseFx") ; "請關閉 Firefox，再執行本程式！"
		ExitApp
	}
}

;" 檢測是否安裝 7Zip
fCheck_7Zip(){
	global _path7zip_, _compressionModule_
	RegRead, _path7zip_, HKEY_LOCAL_MACHINE, SOFTWARE\7-Zip, Path
	if ErrorLevel  ;" 不是空值，也不是0. ;" 不存在的鍵值
	{
		Return, False
	}else IfNotExist, %_path7zip_%\7z.exe
	{	;" 找不到 7z.exe
		Return, False
	}else{
		_compressionModule_	:= "7Zip"
		_path7zip_		:= _path7zip_ . "\7z.exe"
		Return, True
	}
}

;" 檢測是否註冊 zipfldr.dll 檔
fCheck_zipfldrDll(){
	global _compressionModule_
	RegRead, regVar, HKEY_CLASSES_ROOT, .ZFSendToTarget
	if("" = regVar){
		Return, False
	}else{
		_compressionModule_	:= "zipfldr.dll"
		Return, True
	}
}

;" 檢查
fCheck(){
	QA_Create(arrSDP)				;" 建立一個陣列
	fQA_StringSplit(arrSDP, A_ScriptDir, "\")	;" 腳本路徑分段存入陣列
	fIsInExtensionsDir(arrSDP)		;" 檢查本程式放置之目錄
	fIsFxClosed(arrSDP)				;" 檢查 Fx 是否關閉
	check_7Zip		:=	fCheck_7Zip()
	if( False = check_7Zip ){
		blnZipfldrDll	:=	fCheck_zipfldrDll()
		if( False = blnZipfldrDll ){
			MsgBox,	4112,, % fLang("msgNoCompressionModule") ; "未安裝 7Zip 或 zipfldr.dll !"
			ExitApp
		}
	}
}

fGetExtIDandName(){
	global _arrExtID_, _arrExtName_, _arrExtDirName_
	lenEDN	:=	QA_Length(_arrExtDirName_)	;"  extensions 目錄下的資料夾個數
	Loop, %lenEDN%
	{
		extDirName	:=	QA_Get(_arrExtDirName_, A_Index)
		pathIR := A_ScriptDir . "\" . extDirName . "\install.rdf"
		pathCM := A_ScriptDir . "\" . extDirName . "\chrome.manifest"
		if( FileExist(pathIR) && FileExist(pathCM) ){	;" 各資料夾內存在 install.rdf 和 chrome.manifest
			QA_Push(_arrExtID_, extDirName)			;" 套件ID存入陣列
			strRegex	=	em:name(?:>|=`'|=`")(.*)(?:`"|`'|</em:name>)		;" AHK 的轉義符號 ` 
			strTF		:=	TF_Find(pathIR, "", "", strRegex, 1, 1)
			if( strTF ){
				RegExMatch(strTF, strRegex, strExtName)
				QA_Push(_arrExtName_, strExtName1)	;" 套件名存入陣列
			}else{
				QA_Push(_arrExtName_, extDirName)		;" 沒套件名，則用 ID
			}

		}
	}
}

fcleanedDate(extID){
	pathCM := A_ScriptDir . "\" . extID . "\chrome.manifest"
	lastLineNum := TF_CountLines(pathCM)
	strRegex := "# DelFxExtLocal_(\d+)"
	lastCleanedDate := fTF_RegexMatch(pathCM, lastLineNum, lastLineNum, strRegex, 1, 1)
	If ( lastCleanedDate ){
		Return, lastCleanedDate
	}Else{
		Return, fLang("unknown")
	}
}

;" 主介面
fMainGui(){
	global _arrExtName_, _arrExtID_, _compressionModule_, _blnLog_, _Level_, _textEditSave_
	Gui, Font, S10
	Menu, LangMenu, Add, % "English", _lLang_enUS
	Menu, LangMenu, Add, % "中文", _lLang_zhTW
	Menu, HelpMenu, Add, % fLang("menuHomepage"), _lHelpHomepage	; "首頁 (&H)"
	Menu, HelpMenu, Add, % fLang("menuAbout"), _lHelpAbout	; "關於 (&A)"
	
	Menu, MenuBar, Add, % fLang("menuLang"), :LangMenu	; "語言 (&L)"
	Menu, MenuBar, Add, % fLang("menuHelp"), :HelpMenu	; "說明 (&H)"

	Gui, Menu, MenuBar
	
	Gui, Add, Text, +Section, % fLang("muiModule") . _compressionModule_	; "壓縮模組: "
	if( "7Zip" = _compressionModule_ ){
		Gui, Add, Text, +YS, % fLang("muiLevel") 	; "壓縮層級: "
		Gui, Add, DropDownList, +YS Choose1 V_Level_, % fLang("muiLevelList")	; 	"封存|最快速|快速|一般|最大|極致"
	}
	Gui, Add, Text, +YS, % fLang("muiSave")	; "保留語系: en-US,"
	Gui, Add, Edit, +YS V_textEditSave_, % fLang("muiTextEditSave")
	Gui, Add, ListView, +Checked +W600 +R20 +XS +Section, % fLang("muiLvTitle")		; "擴充套件名稱|擴充套件ID|上次清理日期"
	Gui, Add, Button, +YS G_lSelectAll, % fLang("muiSelectAll")	; "全部勾選"
	Gui, Add, Button, +WP G_lUnselectAll, % fLang("muiUnSelectAll")	; "全不勾選"
	Gui, Add, Button, +WP G_lSmart, % fLang("muiSmart")	; "智慧選擇"
	Gui, Add, Button,  +WP G_lClean, % fLang("muiStartClean")	; "開始清理"
	Gui, Add, Checkbox, V_blnLog_, % fLang("muiLogFile")	; "生成記錄檔"
	
	lenExt	:=	QA_Length(_arrExtID_)	;" 套件個數
	Loop, %lenExt%
	{
		extName	:=	QA_Get(_arrExtName_, A_Index)
		extID	:=	QA_Get(_arrExtID_, A_Index)
		cleanedDate := fcleanedDate(extID)
		LV_Add("Check", extName, extID, cleanedDate)
	}
	LV_ModifyCol()  ;" 自動調整大小來適應每列的內容。
	Gui, Add, Text, +XS, % fLang("muiTotal") . lenExt	; "套件數: "
	fSmart()
	Gui, Show
}

;" 執行介面
fProcessGui(){
	global _textEditContent_, _progressValue_, _hwnd_, _Name_, _ReleaseDate_
	_textEditContent_	:=	""		;" 用來儲存 Gui Edit區的內容
	_progressValue_		:=	0
	
	Gui, Font, S16
	Gui, -Caption +Border
	Gui, Add, GroupBox, +Center +W600 +H10, % _Name_

	Gui, Font, S12
	Gui, Add, Text, +W600, % fLang("puiDetails")	; "細節:"
	Gui, Add, Edit, +ReadOnly +W600 +R9 V_textEditContent_ HWND_textEditContentHwnd_
	Gui, Add, Progress, +W600 +H20 +CBlue V_progressValue_
	Gui, Add, Text, +W600 +CRed, % fLang("puiInProcess")	; "執行中...。 請勿強行關閉程式或干擾相關檔案操作！"
	Gui, Show
	
	_hwnd_	:=	_textEditContentHwnd_
}

fSmart(){
	rowNum := LV_GetCount()	;" 總列數
	Loop, %rowNum%
	{
		LV_GetText(lastCleanedDate, A_Index, 3)		;" 第 3 欄
		if ( fLang("unknown") = lastCleanedDate ){
			LV_Modify(A_Index, "Check")
		}else{
			LV_Modify(A_Index, "-Check")
		}
	}
}

;" 將處理進度資料更新至 gui 與 log 檔
fEditGuiAndFile(textNewContent){
	global _pathLogFile_, _textEditContent_, _hwnd_, _blnLog_
	if( _blnLog_ ){
		FileAppend, %textNewContent%, %_pathLogFile_%
	}
	_textEditContent_	:=	_textEditContent_ . textNewContent
	GuiControl,, _textEditContent_, %_textEditContent_%		;" 更新 Gui 內容
	ControlSend,, {Ctrl Down}{End}{Ctrl up}, ahk_id %_hwnd_%		;" ctrl+End 捲軸拉至最底
}

;" 保留的語系目錄
fSaveLang(ByRef arrlocalDirName){
	global _arrLangTag_
	len := QA_Length(_arrLangTag_)
	Loop, %len%
	{
		elm := QA_Get(_arrLangTag_, A_Index)
		fQA_RemoveValue(arrlocalDirName, elm)
	}
}

;" 刪除用不著的語系檔
fDelExtLocal(pathLocalDir){
	SetWorkingDir, %pathLocalDir%
	QA_Create(arrlocalDirName)
	fFileFolderArray(pathLocalDir, 2, arrlocalDirName)
	fSaveLang(arrlocalDirName)
	len	:=	QA_Length(arrlocalDirName)
	Loop, %len%
	{
		localDir	:=	QA_Get(arrlocalDirName, A_Index)
		fEditGuiAndFile( "`n`t" . A_Now . fLang("editDelLocal") . localDir)	; ", 刪除語系檔 "
		FileRemoveDir, %localDir%, 1
	}
}

;" returnFirst = 0 return multiple lines  , =1 return first line only.
;" returnType = 0 return line numbers only , =1 return entire line (text).
fTF_RegexMatch(path, startLine, endLine, strRegex, returnFirst, returnType){
	strTF		:=	TF_Find(path, startLine, endLine, strRegex, returnFirst, returnType)
	If( strTF && 1=returnType ){
		RegExMatch(strTF, strRegex, outputVar)
		Return, outputVar1		;" outputVar 陣列 第1個元素
	}Else If( strTF && 0=returnType ){
		Return, strTF
	}Else{
		Return, 0
	}
}

fDirLocal(language){
	pathFile := "chrome.manifest"
	strRegex	:=	"locale\s.*" . language . "\s+([^\s]+)"	;" 正規表達式 \s 相當於 [\f\n\r\t\v]
	strPath		:=	fTF_RegexMatch(pathFile, "", "", strRegex, 1, 1)
	StringReplace, strPath, strPath, /, \, All			;" 斜線變反斜線
	strRegex	:=	"([^\s]+)\\" . language . "\\"
	RegExMatch(strPath, strRegex, dirLocal)
	Return, dirLocal1
}

;" 解壓縮.jar檔
fUnzipJAR(pathJARDir, jarFileName, zipFileName, pathZipFile, pathUnzDir){
	global _path7zip_
	SetWorkingDir, %pathJARDir%
	fEditGuiAndFile( "`n`t" . A_Now . fLang("editDecompress") . jarFileName)	; ", 解壓縮 "
	FileMove, %jarFileName%, %zipFileName%
	If( "7Zip" = _compressionModule_ ){
		RunWait, %ComSpec% /c ""%_path7zip_%" "x" "%pathZipFile%" "-o%pathUnzDir%"", , Hide 
	}Else{
		Unz(pathZipFile, pathUnzDir)
	}
	FileDelete, %zipFileName%
}

;" 壓縮成.jar檔
fZipJAR(pathJARDir, pathUnzDir, jarFileName, zipFileName){
	global _compressionModule_, _path7zip_, _level_
	SetWorkingDir, %pathJARDir%
	fEditGuiAndFile( "`n`t" . A_Now . fLang("editCompress") . jarFileName)	; ", 壓縮 "
	pathZip	:=	pathJARDir . "\" . zipFileName
	QA_Create(arrFileFolderName)
	fFileFolderArray(pathUnzDir, 1, arrFileFolderName)
	lenFFN	:=	QA_Length(arrFileFolderName)
	Loop, %lenFFN%
	{
		elmFFN	:=	QA_Get(arrFileFolderName, A_Index)
		pathFFN	:=	pathUnzDir . "\" . elmFFN
		fEditGuiAndFile( "`n`t" . A_Now . fLang("editFileOrFloder") . elmFFN . fLang("editAdd2ZipFile") . jarFileName)	; ", 將檔案/資料夾 "	; " 加入壓縮檔 "
		if( "7Zip" = _compressionModule_ ){
			RunWait, %ComSpec% /c ""%_path7zip_%" "a" "-tzip" "%pathZip%" "%pathFFN%" "-mx%_level_%"", , Hide 
		}Else{
			Zip(pathFFN, pathZip)
		}
	}

	FileMove, %zipFileName%, %jarFileName%
}

fEditChromeManifest(extID){
	global _arrLangTag_
	QA_Create(arrLineNum)
	pathCM := A_ScriptDir . "\" . extID . "\chrome.manifest"
	pathCM2 := A_ScriptDir . "\" . extID . "\chrome_copy.manifest"
	language := "[A-Za-z]{2,4}(?:-[A-Za-z]{2,4})*"
	strRegex := "locale\s.*" . language . "\s+([^\s]+)"
	strLineNumList := fTF_RegexMatch(pathCM, "", "", strRegex, 0, 0)
	fQA_StringSplit(arrLineNum, strLineNumList, ",")
	len := 	QA_Length(_arrLangTag_)
	Loop, %len%
	{
		langTag := QA_Get(_arrLangTag_, A_Index)
		strRegex := "locale\s.*" . langTag . "\s+([^\s]+)"
		lineNum := fTF_RegexMatch(pathCM, "", "", strRegex, 1, 0)
		fQA_RemoveValue(arrLineNum, lineNum)
	}

	len := 	QA_Length(arrLineNum)
	Loop, %len%
	{
		lineNum := QA_Get(arrLineNum, A_Index)
		TF_InsertPrefix(pathCM, lineNum, lineNum, "# ")
		FileMove, %pathCM2%, %pathCM%, 1	;" ,1: 覆蓋已存在的檔案
	}

}


fCleanExtLocal(extID){
	SetWorkingDir, %extID%		;" 更改腳本工作目錄 至各個套件目錄
	pathExtDir	:=	A_WorkingDir
	dirLocal	:=	fDirLocal("en-US")	;" en-US 語系檔目錄的相對路徑
	if(	""	!=	dirLocal ){	;" dirLocal 存在, i.e.這套件有語系檔目錄存在
		fEditChromeManifest(extID)
		strRegex	:=	"jar:(?:([^\s]*?)\\?)([^\\\s]+\.jar)!\\([^\s]+)"
		RegExMatch(dirLocal, strRegex, outputVar)
		jarDir		:= outputVar1		;" .jar檔目錄
		jarFileName	:= outputVar2
		if(	""	!=	jarFileName	)
		{
			pathJARDir	:=	pathExtDir . ( (jarDir) ? ("\" . jarDir) : "" )
			StringReplace, zipFileName, jarFileName, .jar, .zip
			pathZipFile	:=	pathJARDir . "\" . zipFileName
			pathUnzDir	:=	pathJARDir . "\TempFolder_DelFxExtLocal"	;" A_Temp . "\TempFolder_DelFxExtLocal_" . extID
			FileCreateDir, %pathUnzDir%	;" 建立暫存資料夾，供解壓縮用
			fUnzipJAR(pathJARDir, jarFileName, zipFileName, pathZipFile, pathUnzDir)
			pathLocalDir:=	pathUnzDir . "\" . outputVar3	
			fDelExtLocal(pathLocalDir)			
			fZipJAR(pathJARDir, pathUnzDir, jarFileName, zipFileName)
			FileRemoveDir, %pathUnzDir%, 1	;" 刪除暫存資料夾
		}else{
			pathLocalDir	:=	pathExtDir . "\" . dirLocal
			fDelExtLocal(pathLocalDir)
		}
	}
	SetWorkingDir, %A_ScriptDir%
}

fMain(){
	global _arrExtID_, _arrExtName_, _progressValue_
	fProcessGui()	;" 執行介面
	fEditGuiAndFile( A_Now . fLang("editStart"))	;" 建立 log 檔， 記錄第一筆資料: 程式開始執行之時間		; ", DelFxExtLocal 開始清理。"
	lenExtID	:=	QA_Length(_arrExtID_)	;" 要處理的套件個數
	Loop, %lenExtID%
	{
		extID	:=	QA_Get(_arrExtID_, A_Index)
		extName :=	QA_Get(_arrExtName_, A_Index)
		value	:=	A_Index/lenExtID*100		;" 進度估計值
		GuiControl,, _progressValue_, %value%	;" 更新進度條
		;" 記錄正在處理哪個套件
		fEditGuiAndFile( "`n`n" . A_Now . fLang("editHandle") . extName)	; ", 處理套件 "
		fCleanExtLocal(extID)	;" 處理套件: 壓縮/解壓縮/刪除
		pathCM := A_ScriptDir . "\" . extID . "\chrome.manifest"
		FileAppend, % "`n# DelFxExtLocal_" . A_Now, %pathCM%
	}
	
	fEditGuiAndFile( "`n`n" . A_Now . fLang("editFinished"))	; ", 全部完成，程式關閉。"
	MsgBox, 4096,, % fLang("msgFinished") ; "已完成！"
	ExitApp
}

fInitialize(){
	global _arrExtDirName_, _arrExtID_, _arrExtName_, _langCode_
	If("0404"=A_Language||"0804"=A_Language||"0c04"=A_Language||"1004"=A_Language||"1404"=A_Language){
		_langCode_ := "zhTW_"
	}else{
		_langCode_ := "enUS_"
	}
	fCheck()	;" 檢查

	fFileFolderArray(A_ScriptDir, 2, _arrExtDirName_)	;" extensions 目錄下的資料夾名稱 存入陣列

	fGetExtIDandName()	;" 獲得套件ID與名稱 
	fMainGui()	;" 主介面
}

fInitialize()
Return

GuiClose:
	ExitApp

_lHelpHomepage:	;" 首頁
	Run, http://forum.moztw.org/viewtopic.php?t=30196
	Return

_lHelpAbout:	;" 關於
	MsgBox,	4096,, % fLang("msgAbout")
	Return

_lLang_enUS:
	_langCode_ := "enUS_"
	Gui, Destroy
	Menu, LangMenu, DeleteAll	
	Menu, HelpMenu, DeleteAll
	Menu, MenuBar, DeleteAll
	fMainGui()
	Return

_lLang_zhTW:
	_langCode_ := "zhTW_"
	Gui, Destroy
	Menu, LangMenu, DeleteAll	
	Menu, HelpMenu, DeleteAll
	Menu, MenuBar, DeleteAll
	fMainGui()
	Return

_lSelectAll:	;" 全部勾選
	LV_Modify(0, "Check")
	Return

_lUnselectAll:	;" 全不勾選
	LV_Modify(0, "-Check")
	Return

_lSmart:	; "智慧選擇"
	fSmart()
	Return

_lClean:	;" 開始清理
	Gui, Submit	;" Saves the contents of each control to its associated variable
	fCheckLangTag(_textEditSave_)
	
	fQA_RemoveAll(_arrExtID_)
	fQA_RemoveAll(_arrExtName_)
	_rowNumber_ := 0  ;" 列號
	Loop
	{
		_rowNumber_ := LV_GetNext(_rowNumber_,"Checked")
		If not _rowNumber_  ;" 返回0，沒有被選中的列了
        Break
		LV_GetText(_elmExtName_, _rowNumber_, 1)	;" 第 1 欄
		LV_GetText(_elmExtID_, _rowNumber_, 2)		;" 第 2 欄
		QA_Push(_arrExtID_, _elmExtID_)
		QA_Push(_arrExtName_, _elmExtName_)
	}

	If( fLang("LevelStore") = _level_ ){
		_level_ := 0	; "封存"
	}Else If( fLang("LevelFastest") = _level_ ){
		_level_ := 1	; "最快速"
	}Else If( fLang("LevelFast") = _level_ ){
		_level_ := 3	; "快速"
	}Else If( fLang("LevelNormal") = _level_ ){
		_level_ := 5	; "一般"
	}Else If( fLang("LevelMaximum") = _level_ ){
		_level_ := 7	; "最大"
	}Else If( fLang("LevelUltra") = _level_ ){
		_level_ := 9	; "極致"
	}
	Gui, Destroy
	fMain()
	Return
